//@line 37 "/home/chris/nsbrowser/mozilla/browser/components/preferences/netscapeCom.js"

var gNetscapeComPane = {
  _inited: false,
  
  get box() { return document.getElementById("netscape_box"); },
  get pref() { return document.getElementById("extensions.netscape.preferences.selectedTabIndex"); },
  
  init: function pane_init() {
  
    // set the selected tab
    this._inited = true;
    if (this.pref.value === null)
      return;
    this.box.selectedIndex = this.pref.value;
    
    // show the alert checkboxes
    this.showAlertCheck();
    
    // get database file       
    this.getDBSize();
  },

  onSelect: function pane_onSelect() {
  
    // not initialized
    if (!this._inited)
      return;
      
    // set the preference
    this.pref.valueFromPreferences = this.box.selectedIndex;
  },
    
  showAlertCheck: function pane_showAlertCheck() {
    var fasCheck = document.getElementById("fas_alert_check");
    var sitemailCheck = document.getElementById("sitemail_alert_check");    
    var show = ("@mozilla.org/alerts-service;1" in Cc)
    if (show) {
      fasCheck.removeAttribute("hidden");
      sitemailCheck.removeAttribute("hidden");      
    } else {
      fasCheck.setAttribute("hidden", "true");
      sitemailCheck.setAttribute("hidden", "true");
    }
  },
  
  getDBSize: function pane_getDBSize() {
    var service = Components.classes["@netscape.com/newslive/service;1"].
                  getService(Components.interfaces.nsINewsliveService);
    var dbFile = service.databaseFile;
    var format, value;
    var bundle = document.getElementById("newslive_bundle");
    if (!dbFile) {
      format = "newslive.prefs.database.unknown";
      value = this.getString(bundle, format);
    } else {
      var fileSize = dbFile.fileSize;
      var KB = parseInt(fileSize/1024);
      var MB = parseInt(KB/1024);
      if (MB > 0) {
        format = "newslive.prefs.database.MB";
        value = this.getString(bundle, format, [MB]);
      } else if (KB > 0) {
        format = "newslive.prefs.database.KB";
        value = this.getString(bundle, format, [KB]);
      } else {
        format = "newslive.prefs.database.B";
        value = this.getString(bundle, format, [fileSize]);
      }
    }
    document.getElementById("newslive_db_label").value = value;
  },
  
  disable: function pane_disable() {
    var names = ["fas_enable_check", "newslive_enable_check", 
                 "sitemail_enable_check", "tracker_enable_check", 
                 "vote_enable_check"];
    for (var i=0; i<names.length; i++) {
      var el = document.getElementById(names[i]);
      var el2 = document.getElementById(el.getAttribute("preference"));
      el2.valueFromPreferences = false;
    }
  },
  
  compactDB: function pane_compactDB() {
    try {
      var service = Components.classes["@netscape.com/newslive/service;1"].
                    getService(Components.interfaces.nsINewsliveService);
      service.compactDB();
      var bundle = document.getElementById("newslive_bundle");
      var label = this.getString(bundle, "newslive.prefs.database.unknown"); 
      document.getElementById("newslive_db_label").value = label;
    } catch(e) {}
  },
  
  getString: function pane_getString(bundle, name, replace) {
    if (!replace)
      return bundle.getString(name);
    else
      return bundle.getFormattedString(name, replace);
  },
  
  openManage: function pane_openManage() {
    this.openWindow("newslive:manage", 
                    "chrome://browser/content/netscape-newslive/newslive-manage.xul", 
                    "chrome=yes,centerscreen=yes,dependent=no,dialog=yes");     
  },
    
  /**
   * Based on toOpenWindowByType in browser.js
   */
  openWindow: function nlu_openWindow(type, url, features) {
    var winMgr = Components.classes['@mozilla.org/appshell/window-mediator;1'].
                 getService(Components.interfaces.nsIWindowMediator);
    var top = winMgr.getMostRecentWindow(type);

    if (top) {
      top.focus();
      return;
    }
  
    if (!features)
      features = "chrome,extrachrome,menubar,resizable,scrollbars,status,toolbar";
    window.open(url, "_blank", features);
  }
};
