function wxBugUpdateForecast() {
	//check last update and compare to interval
	var lu = wxBugGetCharPref(wxBugPrefForecastLastUpdate, 0);
	var inter = wxBugGetIntPref(wxBugPrefForecastInterval, wxBugDefaultInter);
	//var inter = 60000;
	var res = wxBugGetCharPref(wxBugPrefForecastRes);
	
	
	var now = new Date();
	var lastUpdate = new Date();
	lastUpdate.setTime(lu);
	wxBugLog('Forecast last update = ' + lastUpdate);
	wxBugLog('Forecast interval = ' + inter);
	wxBugLog('Forecast diff: ' + (now.getTime() - lu));
	
	
	if (!(res) || wxBugIsDataExpired(lu, inter)) {
		// make http call
		wxBugGetForecast();
	}
	else {
		//read from cache
		wxBugLog('forecast cache');
		//wxBugParseForecastData(res);
	}	
}

function wxBugGetForecast() {
	//wxBugLog('wxBugGetForecast()');
	var url = wxBugGetCharPref(wxBugPrefForecastUrl);
	if (url) {
		url = wxBugDeTokenizeUrl(url);
		wxBugLog('Forecast http: ' + url);
		var ah = new wxBugAsyncHttp(url, 'wxBugParseForecastData');
	}
}


function wxBugParseForecastData(response) {
    wxBugLog('wxBugParseForecastData - ' + response);
    var data = response.split('|');
	var numPer = 0;
	if (data[2]) {
		try {
			numPer = parseInt(data[2]);
		}
		catch(e) {
			numPer = 0;	
		}
	}
	
	var smallUrl = data[0];
	var largeUrl = data[1];
	
	var offset = 0;
	for (i = 0; i <= (numPer - 1); i++) {
		offset = (i * 5) + 3;
		//wxBugLog('wxBugUpdateForecast: ' + i + '  ' + data[offset] + '  ' + data[offset + 1] + '  ' + data[offset + 2] + '  ' + data[offset + 3] + '  ' + data[offset + 4] + '  ' + smallUrl + '  ' + largeUrl);
		wxBugUpdateForecastUi(i, data[offset], data[offset + 1], data[offset + 2], data[offset + 3], data[offset + 4], smallUrl, largeUrl)
	}
	
	 //set the last update time
	var now = new Date();
	wxBugSetCharPref(wxBugPrefForecastLastUpdate, now.getTime());
    
    // write response to cache
	wxBugSetCharPref(wxBugPrefForecastRes, response);
}

function wxBugUpdateForecastUi(num, period, desc, icon, high, low, smallUrl, largeUrl) {
	var foreButton = document.getElementById('wxBugForePer' + num);
	foreButton.src = smallUrl + icon;
	document.getElementById('wxBugForePerTipImg' + num).src = largeUrl + icon;
	document.getElementById('wxBugForePerTipPer' + num).value = period;
	var hilo = ''
	if (high != '--')
		hilo += 'High: ' + high + wxBugGetUnitsDisplay() + '  ';
	if (low != '--')
		hilo += 'Low: ' + low + wxBugGetUnitsDisplay() + '  ';
	
	document.getElementById('wxBugForePerTipHiLo' + num).value = hilo;
}
